#!/usr/bin/perl

use strict;

sub readfile($) {
	my $filename = shift;
	local *INFILE;
	open(*INFILE, "< $filename") or die("$filename: $!\n");
	my @content = <INFILE>;
	close(*INFILE);
	return @content;
}

sub writefile($\@) {
	my $filename = shift;
	local *OUTFILE;
	open(*OUTFILE, "> $filename") or die("$filename: $!\n");
	print OUTFILE @{$_[0]};
	close(*OUTFILE);
}

if ($ARGV[1]) {
	print "Generating $ARGV[0]...";
}
else {
	print "Cleaning $ARGV[0]...";
}

my @filecontent = readfile($ARGV[0]);
my @replacecontent = ($ARGV[1]) ? readfile($ARGV[1]) : ();

my @newcontent = ();

my $foundstart = undef;
my $foundend = undef;

foreach my $line (@filecontent) {
	if ((!$foundstart)&&($line =~ /^\Q#---START_INSTALLATION_SCRIPT---\E/)) {
		$foundstart = 1;
		push @newcontent, "$line";
		push @newcontent, @replacecontent;
	}
	elsif (($foundstart)&&(!$foundend)&&($line =~ /^\Q#---END_INSTALLATION_SCRIPT---\E/)) {
		$foundend = 1;
		push @newcontent, "$line";
	}
	elsif (($foundstart)&&(!$foundend)) {
		# Ignore line
	}
	else {
		push @newcontent, "$line";
	}
}

print "done.\n";

#print join('',@newcontent);
writefile($ARGV[0],@newcontent);

exit(0);
